﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;

using ExtensionMethods;

namespace BibliothequeClassesSDDetGestion
{
    [Serializable]
    public class Contact : ElementArborescence
    {
        // Attributs
        private string _nomContact;
        private string _prenomContact;
        private string _mailContact;
        private string _societeContact;
        private Lien _lienContact;



        public string NomContact { get { return _nomContact; } set { _nomContact = value; } }
        public string PrenomContact { get { return _prenomContact; } set { _prenomContact = value; } }
        public string MailContact { get { return _mailContact; } set { _mailContact = value; } }
        public string SocieteContact { get { return _societeContact; } set { _societeContact = value; } }
        public Lien LienContact { get { return _lienContact; } set { _lienContact = value; } }


        //Constructeur
        public Contact(string nom, string prenom, string mail, string societe, Lien lien, Dossier dossierParent)
        {
            // initialisation attributs de ElementArborescence
            Nom = "Contact" + nom.ToUpper() + prenom.formaterEnNomPropre();
            DateEtHeureCreation = DateTime.Now;
            DateEtHeureModification = DateEtHeureCreation;
            dossierParent.ajouterContactFils(this);

            // initialisation attributs de Contact
            _nomContact = nom.ToUpper();
            _prenomContact = prenom.formaterEnNomPropre();
            _mailContact = mail;
            _societeContact = societe.formaterEnNomPropre();
            _lienContact = lien;
        }

        public Contact()
        {
            // initialisation attributs de ElementArborescence
           Nom = "ContactInconnu";
            DateEtHeureCreation = DateTime.Now;
            DateEtHeureModification = DateEtHeureCreation;

            // initialisation attributs de Contact
            _nomContact = "nomInconnu";
            _prenomContact = "prenomInconnu";
            _mailContact = "mailInconnu";
            _societeContact = "societeInconnue";
            _lienContact = Lien.INCONNU;
        }




        // Méthodes
        public void afficherContact(string espaceProfondeur)
        {
            Console.Write(espaceProfondeur + "Mail de votre " + _lienContact.ToString().ToLower() + " " + _nomContact + " " + _prenomContact + " (travaille à " + _societeContact + ") : " + _mailContact + "\n");
        }





        public void formulaireCreationContact(Dossier dossierParent)
        {
            dossierParent.ajouterContactFils(this);
            List<string> entreesUtilisateur = new List<string>();

            Console.Write("Formulaire de création de nouveauContact, suivez les instructions. Chaque instruction vous fera remplir un champ et il faudra appuyer sur la touche Entrée après le remplissage de chaque champ. Si vous souhaitez laisser le champ inrempli, n'écrivez rien et appuyez sur entrée\n");
            
            Console.Write("Nom : ");
            string entree = Console.ReadLine();
            entree = entree.Trim().ToUpper();
            if(!entree.Equals(""))
            {
                _nomContact = entree;
            }

            Console.Write("Prenom : ");
            entree = Console.ReadLine();
            entree = entree.Trim();
            if (!entree.Equals(""))
            {
                entree = entree.formaterEnNomPropre();
                _prenomContact = entree;
            }

            Console.Write("Mail : ");
            entree = Console.ReadLine();
            entree = entree.Trim();
            if (!entree.Equals(""))
            {
                _mailContact = entree;
            }

            Console.Write("Société (emploi) : ");
            entree = Console.ReadLine();
            entree = entree.Trim();
            if (!entree.Equals(""))
            {
                _societeContact = entree.formaterEnNomPropre();
            }


            int nbrLiens = Enum.GetNames(typeof(Lien)).Count();

            for (int i = 0; i < nbrLiens; i++)
            {
                if(i == 0)
                {
                    Console.Write("Lien avec ce contact (" + (Lien)i + "; ");
                }
                else if(i < nbrLiens - 1)
                {
                    Console.Write((Lien)i + "; ");
                }
                else
                {
                    Console.Write((Lien)i + ") : ");
                }
            }
            entree = Console.ReadLine();
            entree = entree.Trim().ToUpper();
            for(int i = 0; i < nbrLiens; i++)
            {
                if(entree.Equals(((Lien)i).ToString()))
                {
                    _lienContact = (Lien)i;
                }
            }

            Nom = "Contact" + _nomContact + _prenomContact;
        }
        

        /*
        //setters
        public void setLien(Lien nouveauLienContact)
        {
            _lienContact = nouveauLienContact;
        }*/
    }
}
