﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ExtensionMethods;
using System.Security.Cryptography;


namespace BibliothequeClassesSDDetGestion
{
    [Serializable]
    public class Dossier : ElementArborescence
    {
        // attributs
        private List<Dossier> _dossiersFils = new List<Dossier>();
        private List<Contact> _contactsFils = new List<Contact>();

        public List<Dossier> DossiersFils { get { return _dossiersFils; } set { _dossiersFils = value; } }
        public List<Contact> ContactsFils { get { return _contactsFils; } set { _contactsFils = value; } }



       
        //constructeurs
        public Dossier(string nomNouveauDossier, Dossier dossierParent)
        {
            Nom = nomNouveauDossier;
            DateEtHeureCreation = DateTime.Now;
            DateEtHeureModification = DateEtHeureCreation;
            dossierParent.ajouterDossierFils(this);
        }

        public Dossier()
        {
            Nom = "dossierRoot";
            DateEtHeureCreation = DateTime.Now;
            DateEtHeureModification = DateEtHeureCreation;
            DossierParent = this;
        }



        // Méthodes de serialisation / déserialisation
        /*
        public bool deserialiserDossier(string cheminFichierDeSauvegarde, bool trueXMLfalseBIN, Type typeClasse)
        {
            bool operationReussie = false;

            try
            {
                Dossier dossierRecupered;
                if (trueXMLfalseBIN)
                {
                    System.Xml.Serialization.XmlSerializer reader = new System.Xml.Serialization.XmlSerializer(typeof(Dossier));
                    using (System.IO.StreamReader fileLectureXML = new System.IO.StreamReader(cheminFichierDeSauvegarde))
                    {
                        dossierRecupered = (Dossier)reader.Deserialize(fileLectureXML);
                    }
                }
                else
                {
                    System.Runtime.Serialization.Formatters.Binary.BinaryFormatter binReader = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                    using (System.IO.FileStream fileLectureBIN = System.IO.File.OpenRead(cheminFichierDeSauvegarde))
                    {
                        dossierRecupered = (Dossier)binReader.Deserialize(fileLectureBIN);
                    }
                }

                dossierRecupered.retablirHierarchieFille();
                this.ajouterDossierFils(dossierRecupered);
                operationReussie = true;
            }
            catch(System.IO.FileNotFoundException)
            {
                Console.Write("Fichier non trouvé (conseil : réessayez sans '.xml' ou '.txt'), en attendant : ");
            }
            catch(System.InvalidOperationException)
            {
                Console.Write("Apparemment, le fichier serait corrompu, en conséquence : ");
            }
            catch(System.Runtime.Serialization.SerializationException e)
            {
                Console.Write("Erreur de déserialisation :  " + e + ": ");
            }
            catch(System.IndexOutOfRangeException e)
            {
                Console.Write("Apparemment, le fichier serait corrompu " + e + " : ");
            }

            return operationReussie;
        }*/


        public bool deserialiserFichierIntoElementArborescence(string cheminFichier, bool trueXMLfalseBIN, bool trueDossierFalseContact)
        {
            bool operationReussie = false;

            Type TypeObjectRecupered;
            if(trueDossierFalseContact)
            {
                TypeObjectRecupered = typeof(Dossier);
            }
            else
            {
                TypeObjectRecupered = typeof(Contact);
            }

            if (trueXMLfalseBIN)
            {
                cheminFichier += ".xml";
            }
            else
            {
                cheminFichier += ".txt";
            }


            try
            {
                //Object objectRecupered;
                if(trueDossierFalseContact)
                {
                    Dossier dossierRecupered;
                    if (trueXMLfalseBIN)
                    {
                        System.Xml.Serialization.XmlSerializer xmlReader = new System.Xml.Serialization.XmlSerializer(TypeObjectRecupered);
                        using (System.IO.StreamReader fileLectureXML = new System.IO.StreamReader(cheminFichier))
                        {
                            dossierRecupered = (Dossier)xmlReader.Deserialize(fileLectureXML);
                        }
                    }
                    else
                    {
                        System.Runtime.Serialization.Formatters.Binary.BinaryFormatter binReader = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                        using (System.IO.FileStream fileLectureBIN = System.IO.File.OpenRead(cheminFichier))
                        {
                            dossierRecupered = (Dossier)binReader.Deserialize(fileLectureBIN);
                        }
                    }
                    dossierRecupered.retablirHierarchieFille();
                    this.ajouterDossierFils(dossierRecupered);
                }
                else
                {
                    Contact contactRecupered;
                    if (trueXMLfalseBIN)
                    {
                        System.Xml.Serialization.XmlSerializer xmlReader = new System.Xml.Serialization.XmlSerializer(TypeObjectRecupered);
                        using (System.IO.StreamReader fileLectureXML = new System.IO.StreamReader(cheminFichier))
                        {
                            contactRecupered = (Contact)xmlReader.Deserialize(fileLectureXML);
                        }
                    }
                    else
                    {
                        System.Runtime.Serialization.Formatters.Binary.BinaryFormatter binReader = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                        using (System.IO.FileStream fileLectureBIN = System.IO.File.OpenRead(cheminFichier))
                        {
                            contactRecupered = (Contact)binReader.Deserialize(fileLectureBIN);
                        }
                    }
                    this.ajouterContactFils(contactRecupered);
                }

                operationReussie = true;
            }
            catch (System.Exception exception)
            {
                Console.Write($"Echec de la déserialisation " + exception + " \n");
            }

            /*
            catch (System.IO.FileNotFoundException)
            {
                Console.Write("Fichier non trouvé (conseil : réessayez sans '.xml' ou '.txt'), en attendant : ");
            }
            catch (System.InvalidOperationException)
            {
                Console.Write("Apparemment, le fichier XMl serait corrompu, en conséquence : ");
            }
            catch(System.Runtime.Serialization.SerializationException)
            {
                Console.Write("Apparemment, le fichier BIN serait corrompu, en conséquence : ");
            }
            catch(System.Exception e)
            {
                Console.Write(e);
            }*/


            return operationReussie;
        }



        public void retablirHierarchieFille()
        {
            foreach (Dossier dossierFils in _dossiersFils)
            {
                dossierFils.DossierParent = this;
                dossierFils.retablirHierarchieFille();
            }
            foreach (Contact contactFils in _contactsFils)
            {
                contactFils.DossierParent = this;
            }
        }


        public bool dechiffrerDeserialiserFichierIntoElementArborescence(string cheminFichier, bool trueXMLfalseBIN, bool trueDossierFalseContact, string password)
        {
            bool operationNickel = false;

            Type TypeObjectRecupered;
            if (trueDossierFalseContact)
            {
                TypeObjectRecupered = typeof(Dossier);
            }
            else
            {
                TypeObjectRecupered = typeof(Contact);
            }

            if (trueXMLfalseBIN)
            {
                cheminFichier += ".xml";
            }
            else
            {
                cheminFichier += ".txt";
            }

            try
            {
                byte[] keyPassword = new byte[16];
                keyPassword = keyPassword.createKeyUsingPassword(password);

                using (Aes aes = Aes.Create())
                {
                    using (System.IO.FileStream fileLecture = System.IO.File.OpenRead(cheminFichier))
                    {
                        byte[] iv = new byte[aes.IV.Length];
                        int numBytesToRead = aes.IV.Length;
                        int numBytesRead = 0;
                        while (numBytesToRead > 0)
                        {
                            int n = fileLecture.Read(iv, numBytesRead, numBytesToRead);
                            if (n == 0) break;

                            numBytesRead += n;
                            numBytesToRead -= n;
                        }

                        /*
                        byte[] key =
                        {
                             0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,
                            0x09, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 112
                        };*/

                        aes.Key = keyPassword;
                        aes.IV = iv;

                        using (CryptoStream cryptoStream = new CryptoStream(fileLecture, aes.CreateDecryptor(), CryptoStreamMode.Read))
                        {
                            Object objectRecupered;
                            if (trueXMLfalseBIN)
                            {
                                System.Xml.Serialization.XmlSerializer xmlReader = new System.Xml.Serialization.XmlSerializer(TypeObjectRecupered);
                                objectRecupered = xmlReader.Deserialize(cryptoStream);
                            }
                            else
                            {
                                System.Runtime.Serialization.Formatters.Binary.BinaryFormatter binReader = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                                objectRecupered = binReader.Deserialize(cryptoStream);
                            }

                            if (trueDossierFalseContact)
                            {
                                Dossier dossierRecupered = (Dossier)objectRecupered;
                                dossierRecupered.retablirHierarchieFille();
                                this.ajouterDossierFils(dossierRecupered);
                            }
                            else
                            {
                                Contact contactRecupered = (Contact)objectRecupered;
                                this.ajouterContactFils(contactRecupered);
                            }

                            operationNickel = true;
                        }
                    }
                }
            }
            catch (System.Exception exception)
            {
                Console.Write($"Echec de la déserialisation et du déchiffrement. " + exception + " \n");
            }
            /*
            catch (System.IO.FileNotFoundException)
            {
                Console.Write("Fichier non trouvé (conseil : réessayez sans '.xml' ou '.txt'), en attendant : ");
            }
            catch (System.InvalidOperationException)
            {
                Console.Write("Apparemment, le fichier serait corrompu, en conséquence : ");
            }
            catch (System.Runtime.Serialization.SerializationException e)
            {
                Console.Write("Erreur de déserialisation :  " + e + ": ");
            }
            catch (System.IndexOutOfRangeException e)
            {
                Console.Write("Apparemment, le fichier serait corrompu " + e + " : ");
            }
            catch (Exception ex)
            {
                Console.WriteLine($"The encryption failed. {ex}");
            }*/

            return operationNickel;
        }





        public void afficherPrompt()
        {
            Console.ForegroundColor = ConsoleColor.Green;
            Console.Write(Environment.UserName + "@gestionnaireContacts");
            Console.ResetColor();
            Console.Write(":");
            Console.ForegroundColor = ConsoleColor.Blue;
            Console.Write("~");

            Dossier dossierCourantFictif = this;
            string cheminAbsolu = "";
            while (!dossierCourantFictif.Equals(dossierCourantFictif.DossierParent))
            {
                cheminAbsolu = "/" + dossierCourantFictif.Nom + cheminAbsolu;
                dossierCourantFictif = dossierCourantFictif.DossierParent;
            }
            cheminAbsolu = "/" + dossierCourantFictif.Nom + cheminAbsolu;
            Console.Write(cheminAbsolu);

            Console.ResetColor();
            Console.Write("$");
        }



        //  Méthodes d'ajout
        public void ajouterDossierFils(Dossier nouveauDossierFils)
        {
            DateEtHeureModification = DateTime.Now;
            _dossiersFils.Add(nouveauDossierFils);
            nouveauDossierFils.DossierParent = this;
        }

        public void ajouterContactFils(Contact nouveauContactFils)
        {
            DateEtHeureModification = DateTime.Now;
            _contactsFils.Add(nouveauContactFils);
            nouveauContactFils.DossierParent = this;
        }




        // Méthodes d'affichage
        public void afficherDossier()
        {
            Console.Write(Nom + " --> " + _dossiersFils.Count() + " dossiers et " + _contactsFils.Count() + " contacts\n");
        }


        public void afficherArborescenceFille(string espaceProfondeur)
        {
            Console.Write(espaceProfondeur);
            afficherDossier();

            foreach (Dossier dossier in _dossiersFils)
            {
                dossier.afficherArborescenceFille("     |" + espaceProfondeur);
            }

            afficherContactsFils("     |" + espaceProfondeur, false);
        }



        public void afficherDossierEtSonContenu(bool boolAfficherInfosTemporelles)
        {
            if(boolAfficherInfosTemporelles)
            {
                afficherInfosTemporelles();
            }
            afficherDossier();
            foreach (Dossier dossier in _dossiersFils)
            {
                if (boolAfficherInfosTemporelles)
                {
                    Console.Write("     ");
                    dossier.afficherInfosTemporelles();
                }
                Console.Write("     ");
                dossier.afficherDossier();
            }
            afficherContactsFils("     ", boolAfficherInfosTemporelles);
        }


        public void afficherContactsFils(string espaceProfondeur, bool afficherInfosTemporelles)
        {
            foreach(Contact contact in _contactsFils)
            {
                if (afficherInfosTemporelles)
                {
                    Console.Write(espaceProfondeur);
                    contact.afficherInfosTemporelles();
                }
                contact.afficherContact(espaceProfondeur);
            }
        }
    }
}
