﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Security.Cryptography;

namespace ExtensionMethods
{
    public static class MyExtensions
    {
        public static string formaterEnNomPropre(this string prenomDeBase)
        {
            string premiereLettre = prenomDeBase.Substring(0, 1);
            string reste = prenomDeBase.Substring(1);
            premiereLettre = premiereLettre.ToUpper();
            reste = reste.ToLower();

            string prenomDeBaseModificated = premiereLettre + reste;
            return prenomDeBaseModificated;
        }

        public static string enleverChar(this string stringDeBase, char charToRemove)
        {
            List<String> boutsDeStringDeBase = new List<string>(stringDeBase.Split(charToRemove));
            string stringToreturn = "";
            foreach (string boutDeStringDeBase in boutsDeStringDeBase)
            {
                stringToreturn += boutDeStringDeBase;
            }

            return stringToreturn;
        }

        public static bool estDansList(this List<int> listeDeBase, int indiceRecherched)
        {
            bool estDedans = false;

            foreach(int intDansListeDeBase in listeDeBase)
            {
                if(indiceRecherched == intDansListeDeBase)
                {
                    estDedans = true;
                }
            }

            return estDedans;
        }


        public static byte[] createKeyUsingPassword(this byte[] tableauByte, string password)
        {
            int hash = password.GetHashCode();
            if (hash < 0)
            {
                hash *= -1;
            }

            int diviseur = 1;
            int modulo = 256;
            //Console.Write(hash + "\n\n");
            for (int i = 0; i < 16; i++)
            {
                tableauByte[i] = (byte)(((hash / diviseur) + 1)% modulo);
                diviseur = tableauByte[i];

               // Console.Write(tableauByte[i] + "\n");
            }

            return tableauByte;
        }


        public static bool chiffrerFichierAvecCeChemin(this string cheminFichier, string password, string extension)
        {
            bool chiffrageNickel = true;

            byte[] keyPassword = new byte[16];
            keyPassword = keyPassword.createKeyUsingPassword(password);

            try
            {
                using (System.IO.FileStream fileStream = new System.IO.FileStream(cheminFichier + "_CRYPTED" + extension, System.IO.FileMode.OpenOrCreate))
                {
                    using (Aes aes = Aes.Create())
                    {
                        /*
                        byte[] key =
                        {
                             0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,
                            0x09, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 112
                        };*/
                        aes.Key = keyPassword;

                        byte[] iv = aes.IV;
                        fileStream.Write(iv, 0, iv.Length);

                        using (CryptoStream cryptoStream = new CryptoStream(fileStream, aes.CreateEncryptor(), CryptoStreamMode.Write))
                        {
                            // By default, the StreamWriter uses UTF-8 encoding.
                            // To change the text encoding, pass the desired encoding as the second parameter.
                            // For example, new StreamWriter(cryptoStream, Encoding.Unicode).
                            using (System.IO.StreamWriter encryptWriter = new System.IO.StreamWriter(cryptoStream, Encoding.Unicode))
                            {
                                string textePourChiffrage = System.IO.File.ReadAllText(cheminFichier + extension);
                                encryptWriter.WriteLine(textePourChiffrage);
                                System.IO.File.Delete(cheminFichier + extension);
                            }
                        }
                    }
                }

                Console.WriteLine("The file was encrypted.");
            }
            catch (Exception ex)
            {
                Console.WriteLine($"The encryption failed. {ex}");
                chiffrageNickel = false;
            }

            return chiffrageNickel;
        }


        public static bool dechiffrerFichierAvecCeChemin(this string cheminFichier, string password, string extension)
        {
            bool chiffrageNickel = true;

            byte[] keyPassword = new byte[16];
            keyPassword = keyPassword.createKeyUsingPassword(password);

            try
            {
                using (System.IO.FileStream fileStream = new System.IO.FileStream(cheminFichier + "_CRYPTED" + extension, System.IO.FileMode.Open))
                {
                    using (Aes aes = Aes.Create())
                    {
                        byte[] iv = new byte[aes.IV.Length];
                        int numBytesToRead = aes.IV.Length;
                        int numBytesRead = 0;
                        while (numBytesToRead > 0)
                        {
                            int n = fileStream.Read(iv, numBytesRead, numBytesToRead);
                            if (n == 0) break;

                            numBytesRead += n;
                            numBytesToRead -= n;
                        }

                        /*
                        byte[] key =
                        {
                             0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,
                            0x09, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 112
                        };*/

                        aes.Key = keyPassword;
                        aes.IV = iv;

                        using (CryptoStream cryptoStream = new CryptoStream(fileStream, aes.CreateDecryptor(), CryptoStreamMode.Read))
                        {
                            // By default, the StreamReader uses UTF-8 encoding.
                            // To change the text encoding, pass the desired encoding as the second parameter.
                            // For example, new StreamReader(cryptoStream, Encoding.Unicode).
                            using (System.IO.StreamReader decryptReader = new System.IO.StreamReader(cryptoStream, Encoding.Unicode))
                            {
                                string decryptedMessage = decryptReader.ReadToEnd().Trim();
                                Console.WriteLine($"The decrypted original message: {decryptedMessage}");

                                System.IO.File.WriteAllText(cheminFichier + extension, decryptedMessage);
                            }
                        }
                    }
                }
                System.IO.File.Delete(cheminFichier + "_CRYPTED" + extension);
            }
            catch (Exception ex)
            {
                Console.WriteLine($"The decryption failed. {ex}");
                chiffrageNickel = false;
            }

            return chiffrageNickel;
        }
    }
}
