﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Security.Cryptography;

using BibliothequeClassesSDDetGestion;
using ExtensionMethods;



/***********************Développement.NET C# *************************
          -- > TP noté - Programmation ContactManager | S1 ZZ2 F2
------------------------------------------------------------------------
		Code écrit par Anaël Courjaud en Janvier 2023
	  Dernière modification le 29/01/2023 par Anaël Courjaud
-----------------------------------------------------------------------*/



namespace projetGestionnaireDeContacts
{
    class Program
    {
        const string cheminCommun = "../../../_ReceptionFichiersDeSauvegarde/";
        const string particuleFichierXML = "FichiersXML/";
        const string particuleFichierBIN = "FichiersBIN/";
        const string particuleDossier = "Dossiers/";
        const string particuleContact = "Contacts/";
        const string particuleUncrypted = "Uncrypted/";
        const string particuleCrypted = "Crypted/";

        static void Main(string[] args)
        {
            List<int> intCommandesDemandantPrecisions = new List<int> {(int)Commande.SAUV, (int)Commande.SHOW, (int)Commande.GET };
            List<int> intCommandesContenantPrecisions = new List<int> { (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVCONTACTBIN, (int)Commande.SAUVENCRYPTCONTACTBIN,
                                                                        (int)Commande.SHOWDOSSIERSXML, (int)Commande.SHOWCRYPTEDDOSSIERSXML, (int)Commande.SHOWDOSSIERSBIN, (int)Commande.SHOWCRYPTEDDOSSIERSBIN, (int)Commande.SHOWCONTACTSXML, (int)Commande.SHOWCRYPTEDCONTACTSXML, (int)Commande.SHOWCONTACTSBIN, (int)Commande.SHOWCRYPTEDCONTACTSBIN,
                                                                        (int)Commande.GETDOSSIERXML, (int)Commande.GETDECRYPTDOSSIERXML, (int)Commande.GETDOSSIERBIN, (int)Commande.GETDECRYPTDOSSIERBIN, (int)Commande.GETCONTACTXML, (int)Commande.GETDECRYPTCONTACTXML, (int)Commande.GETCONTACTBIN, (int)Commande.GETDECRYPTCONTACTBIN};

            List<int> intCommandesSAUV = new List<int> { (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVCONTACTBIN, (int)Commande.SAUVENCRYPTCONTACTBIN };
            List<int> intCommandesSHOW = new List<int> { (int)Commande.SHOWDOSSIERSXML, (int)Commande.SHOWCRYPTEDDOSSIERSXML, (int)Commande.SHOWDOSSIERSBIN, (int)Commande.SHOWCRYPTEDDOSSIERSBIN, (int)Commande.SHOWCONTACTSXML, (int)Commande.SHOWCRYPTEDCONTACTSXML, (int)Commande.SHOWCONTACTSBIN, (int)Commande.SHOWCRYPTEDCONTACTSBIN };
            List<int> intCommandesGET = new List<int> { (int)Commande.GETDOSSIERXML, (int)Commande.GETDECRYPTDOSSIERXML, (int)Commande.GETDOSSIERBIN, (int)Commande.GETDECRYPTDOSSIERBIN, (int)Commande.GETCONTACTXML, (int)Commande.GETDECRYPTCONTACTXML, (int)Commande.GETCONTACTBIN, (int)Commande.GETDECRYPTCONTACTBIN };

            List<int> intCommandesDemandantPassword = new List<int> { (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTBIN, (int)Commande.GETDECRYPTDOSSIERXML, (int)Commande.GETDECRYPTDOSSIERBIN, (int)Commande.GETDECRYPTCONTACTXML, (int)Commande.GETDECRYPTCONTACTBIN };

            List<int> intCommandesConcernedParIndiceDossier = new List<int> { (int)Commande.CD, (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN };
            List<int> intCommandesConcernedParIndiceContact = new List<int> { (int)Commande.SAUVCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVCONTACTBIN, (int)Commande.SAUVENCRYPTCONTACTBIN };

            List<int> intCommandesConcernedPar1 = new List<int> { (int)Commande.MAN, (int)Commande.TREE, (int)Commande.LSDATE, (int)Commande.LS, (int)Commande.MKCONTACT, (int)Commande.EXIT, (int)Commande.CD, (int)Commande.SAUV, (int)Commande.SHOW, (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SHOWDOSSIERSXML, (int)Commande.SHOWCRYPTEDDOSSIERSXML, (int)Commande.SHOWDOSSIERSBIN, (int)Commande.SHOWCRYPTEDDOSSIERSBIN, (int)Commande.SHOWCONTACTSXML, (int)Commande.SHOWCRYPTEDCONTACTSXML, (int)Commande.SHOWCONTACTSBIN, (int)Commande.SHOWCRYPTEDCONTACTSBIN };
            List<int> intCommandesConcernedPar2int = new List<int> { (int)Commande.CD, (int)Commande.SAUV, (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVCONTACTBIN, (int)Commande.SAUVENCRYPTCONTACTBIN };
            List<int> intCommandesConcernedPar2string = new List<int> { (int)Commande.MKDIR, (int)Commande.SAUV, (int)Commande.GET, (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.GETDOSSIERXML, (int)Commande.GETDECRYPTDOSSIERXML, (int)Commande.GETDOSSIERBIN, (int)Commande.GETDECRYPTDOSSIERBIN, (int)Commande.GETCONTACTXML, (int)Commande.GETDECRYPTCONTACTXML, (int)Commande.GETCONTACTBIN, (int)Commande.GETDECRYPTCONTACTBIN };
            List<int> intCommandesConcernedPar3intString = new List<int> { (int)Commande.SAUV, (int)Commande.SAUVDOSSIERXML, (int)Commande.SAUVENCRYPTDOSSIERXML, (int)Commande.SAUVDOSSIERBIN, (int)Commande.SAUVENCRYPTDOSSIERBIN, (int)Commande.SAUVCONTACTXML, (int)Commande.SAUVENCRYPTCONTACTXML, (int)Commande.SAUVCONTACTBIN, (int)Commande.SAUVENCRYPTCONTACTBIN };


            Dictionary<int, string> dictionnaireInfosMan = new Dictionary<int, string>();
            dictionnaireInfosMan.Add((int)Commande.INUTILE, " : Ne fais rien\n");
            dictionnaireInfosMan.Add((int)Commande.MAN, " : Affiche le détail des commandes existantes avec des explications.");
            dictionnaireInfosMan.Add((int)Commande.TREE, " : Affiche l'arborescence fille du dossier courant.");
            dictionnaireInfosMan.Add((int)Commande.LS, " : Affiche le contenu du dossier courant (dossiers fils et contacts fils).");
            dictionnaireInfosMan.Add((int)Commande.LSDATE, " : Affiche le contenu du dossier courant en précisant les dates de création et de modification.");
            dictionnaireInfosMan.Add((int)Commande.MKDIR, " : Crée un dossier avec le nom donné en paramètre dans le dossier courant.");
            dictionnaireInfosMan.Add((int)Commande.MKCONTACT, " : Crée un contact dans le dossier courant et ouvre un formulaire pour entrer les infos du contact.");
            dictionnaireInfosMan.Add((int)Commande.EXIT, " : Quitte proprement le programme et ferme la présente console.");
            dictionnaireInfosMan.Add((int)Commande.CD, " : Change de dossier, indice négatif pour dossiers parents, positif  pour dossiers fils, pas d'indice pour racine.\n\n\n   *Les 3 commandes globales suivantes permettent d'accéder facilement aux 24 commandes d'après, très précises mais très longues à taper. En revanche, les noms des commandes sont plutôt explicites.*\n   *Vous pouvez aussi taper directement le nom complet des longues commandes. Dans tous les cas, n'oubliez pas d'ajouter la bonne composition de paramètres.*\n");
            dictionnaireInfosMan.Add((int)Commande.SAUV, "");
            dictionnaireInfosMan.Add((int)Commande.SHOW, "");
            dictionnaireInfosMan.Add((int)Commande.GET, "\n\n   *Commandes découlant de SAUV*");
            dictionnaireInfosMan.Add((int)Commande.SAUVENCRYPTCONTACTBIN, "\n\n   *Commandes découlant de SHOW*");
            dictionnaireInfosMan.Add((int)Commande.SHOWCRYPTEDCONTACTSBIN, "\n\n   *Commandes découlant de GET*");



            Dossier dossierRoot = new Dossier();
            Dossier dossierCourant = dossierRoot;

            
            
            bool continuer = true;
            while(continuer)
            {
                Console.Write("\nPour avoir de l'aide, tapez 'man' + entrée\n");
                dossierCourant.afficherPrompt();



                // TRAITEMENT ENTREE UTILISATEUR //
                ///////////////////////////////////////////////////////
                Commande commandePassed = Commande.INUTILE;
                bool commandeValide = true;
                int nbrElementsCommande = 0;
                bool indicePassedEnCommandeEstUnInt = false;
                bool parametresHeterogenes = true;
                int indicePassedEnCommande = 0;
                string stringpassedEnCommande = "";
                bool problemeDeFichier = false;
                string passwordSaisi = "";
                int nbrCommandes = Enum.GetNames(typeof(Commande)).Count();

                string cheminFichier = "";
                bool trueXMLfalseBIN = true;
                bool trueDossierfalseContact = true;
                bool trueUncryptedFalseCrypted = true;
                ///////////////////////////////////////////////////////

                // acquisition commande
                string commande = Console.ReadLine();
                commande = commande.Trim();

                // traitement entête commande (ordre)
                List<string> commandeSplitted = new List<string>(commande.Split(' '));
                nbrElementsCommande = commandeSplitted.Count();
                commandeSplitted[0] = commandeSplitted[0].ToUpper();
                for(int i = 0; i < nbrCommandes; i++)
                {
                    if(commandeSplitted[0].Equals(((Commande)i).ToString()))
                    {
                        commandePassed = (Commande)i;
                    }
                }

                if (intCommandesDemandantPrecisions.estDansList((int)commandePassed))
                {
                    int intCommandePassedTkt = (int)commandePassed - (int)Commande.SAUV;

                    bool choixValide = false;
                    while (!choixValide)
                    {
                        Console.Write("Précisez votre commande en choisissant un chiffre parmi : \n");
                        for (int i = 0; i < 8; i++)
                        {
                            Console.Write(i + " : " + (Commande)intCommandesContenantPrecisions[i + intCommandePassedTkt * 8] + "\n");
                        }
                        Console.Write("Votre choix : ");
                        string choix = Console.ReadLine();
                        int intChoix;
                        if (int.TryParse(choix, out intChoix))
                        {
                            if (intChoix >= 0 && intChoix < 8)
                            {
                                commandePassed = (Commande)intCommandesContenantPrecisions[intChoix + intCommandePassedTkt * 8];
                                choixValide = true;
                            }
                            else
                            {
                                Console.Write("Le nombre que vous avez saisi n'est pas compris entre 0 et 7 inclus, recommencez !\n");
                            }
                        }
                        else
                        {
                            Console.Write("Votre saisie n'est pas un nombre, recommencez !\n");
                        }
                    }
                }

                if(intCommandesContenantPrecisions.estDansList((int)commandePassed))
                {
                    // Déterminer les spécificités de cette commande
                    cheminFichier = cheminCommun;
                    int numeroAnalyseCommande = (int)commandePassed - (int)Commande.SAUVDOSSIERXML;
                    numeroAnalyseCommande %= 8;
                    if (numeroAnalyseCommande % 2 == 0)
                    {
                        trueUncryptedFalseCrypted = true;
                        cheminFichier += particuleUncrypted;
                    }
                    else
                    {
                        trueUncryptedFalseCrypted = false;
                        cheminFichier += particuleCrypted;
                        numeroAnalyseCommande -= 1;
                    }
                    numeroAnalyseCommande /= 2;
                    if (numeroAnalyseCommande % 2 == 0)
                    {
                        trueXMLfalseBIN = true;
                        cheminFichier += particuleFichierXML;
                    }
                    else
                    {
                        trueXMLfalseBIN = false;
                        cheminFichier += particuleFichierBIN;
                        numeroAnalyseCommande -= 1;
                    }
                    numeroAnalyseCommande /= 2;
                    if (numeroAnalyseCommande % 2 == 0)
                    {
                        trueDossierfalseContact = true;
                        cheminFichier += particuleDossier;
                    }
                    else
                    {
                        trueDossierfalseContact = false;
                        cheminFichier += particuleContact;
                    }

                    //Console.Write("dossier : " + trueDossierfalseContact + "\nxml : " + trueXMLfalseBIN + "\nUncrypted : " + trueUncryptedFalseCrypted + "\n");
                }
                Console.Write("Vous avez passé la commande " + commandePassed + "\n");


               
                                

                if(commandePassed == Commande.INUTILE)
                {
                    commandeValide = false;
                }
                else
                {
                    // traitement corps commande (parametres)
                    if (nbrElementsCommande > 1)
                    {
                        if (nbrElementsCommande == 2)
                        {
                            indicePassedEnCommandeEstUnInt = int.TryParse(commandeSplitted[1], out indicePassedEnCommande);
                            if (!indicePassedEnCommandeEstUnInt)
                            {
                                stringpassedEnCommande = commandeSplitted[1].enleverChar('.');
                            }
                        }
                        else if (nbrElementsCommande == 3)
                        {
                            bool commandeSplitted1EstUnInt = int.TryParse(commandeSplitted[1], out indicePassedEnCommande);
                            bool commandeSplitted2EstUnInt = int.TryParse(commandeSplitted[2], out indicePassedEnCommande);

                            if (commandeSplitted1EstUnInt == commandeSplitted2EstUnInt)
                            {
                                parametresHeterogenes = false;
                            }
                            else
                            {
                                indicePassedEnCommandeEstUnInt = true;
                                if (commandeSplitted1EstUnInt)
                                {
                                    int.TryParse(commandeSplitted[1], out indicePassedEnCommande);
                                    stringpassedEnCommande = commandeSplitted[2].enleverChar('.');
                                }
                                else
                                {
                                    int.TryParse(commandeSplitted[2], out indicePassedEnCommande);
                                    stringpassedEnCommande = commandeSplitted[1].enleverChar('.');
                                }
                            }
                        }
                    }



                    // Traitement erreur de nombre ou de type de paramètres par rapport à l'ordre
                    bool pasLeBonNombreParametres = false;
                    switch (nbrElementsCommande)
                    {
                        case 1:
                            if (!intCommandesConcernedPar1.estDansList((int)commandePassed))
                            {
                                pasLeBonNombreParametres = true;
                            }
                            break;
                        case 2:
                            bool intRequiered = intCommandesConcernedPar2int.estDansList((int)commandePassed);
                            bool stringRequired = intCommandesConcernedPar2string.estDansList((int)commandePassed);

                            if (!intRequiered && !stringRequired)
                            {
                                pasLeBonNombreParametres = true;
                            }
                            else if (intRequiered && !stringRequired)
                            {
                                if (!indicePassedEnCommandeEstUnInt)
                                {
                                    Console.Write("Vous avez entré un nom (string) alors que cette commande nécessite un indice (int). Réessayez avec un indice (int), en attendant : ");
                                    commandeValide = false;
                                }
                            }
                            else if (!intRequiered && stringRequired)
                            {
                                if (indicePassedEnCommandeEstUnInt)
                                {
                                    Console.Write("Vous avez entré un indice (int) alors que cette commande nécessite un nom (string). Réessayez avec un nom (string), en attendant : ");
                                    commandeValide = false;
                                }
                            }
                            break;
                        case 3:
                            if (!intCommandesConcernedPar3intString.estDansList((int)commandePassed))
                            {
                                pasLeBonNombreParametres = true;
                            }
                            else
                            {
                                if (!parametresHeterogenes)
                                {
                                    Console.Write("Vous avez entré deux indices (int) ou deux noms (string) alors que cette commande nécessite comme parametre un indice (int) et un nom (string). Réessayez avec des paramètres de types hétérogènes, en attendant : ");
                                    commandeValide = false;
                                }
                            }
                            break;
                        default:
                            Console.Write("Trop de paramètres dans la commande. En conséquence : ");
                            commandeValide = false;
                            break;
                    }
                    if (pasLeBonNombreParametres)
                    {
                        Console.Write("Vous n'avez pas entré le bon nombre de paramètres pour cette commande. Réessayez avec le bon nombre, en attendant : ");
                        commandeValide = false;
                    }


                    
                    if(commandeValide)
                    {
                        // Traitement erreurs d'indice
                        if (indicePassedEnCommandeEstUnInt)
                        {
                            if (indicePassedEnCommande >= dossierCourant.DossiersFils.Count() && indicePassedEnCommande >= dossierCourant.ContactsFils.Count())
                            {
                                Console.Write("Il n'existe pas d'élément d'indice " + indicePassedEnCommande + " dans ce dossier " + dossierCourant.Nom + ". En conséquence : ");
                                commandeValide = false;
                            }
                            else
                            {
                                if (intCommandesConcernedParIndiceDossier.estDansList((int)commandePassed)) // si la commande est concernée par les indices dossiers
                                {
                                    if(indicePassedEnCommande >= 0)
                                    {
                                        if (dossierCourant.DossiersFils.Count() == 0)
                                        {
                                            Console.Write("Ce dossier " + dossierCourant.Nom + " ne contient pas d'autres dossiers. En conséquence : ");
                                            commandeValide = false;
                                        }
                                        else
                                        {
                                            if (indicePassedEnCommande >= dossierCourant.DossiersFils.Count())
                                            {
                                                int borneMax = dossierCourant.DossiersFils.Count() - 1;
                                                Console.Write("Vous confondez un Dossier avec un Contact mdr. Pour manipuler un dossier contenu dans " + dossierCourant.Nom + ", réessayez avec un indice compris entre 0 et " + borneMax + " inclus, ou alors entrez un indice négatif pour manipuler un dossier parent... En attendant : ");
                                                commandeValide = false;
                                            }
                                        }
                                    }
                                }
                                if (intCommandesConcernedParIndiceContact.estDansList((int)commandePassed)) // si la commande est concernée par les indices contacts
                                {
                                    if (indicePassedEnCommande < 0)
                                    {
                                        Console.Write("L'indice d'un Contact ne peut pas être négatif. En conséquence : ");
                                        commandeValide = false;
                                    }
                                    else
                                    {
                                        if (dossierCourant.ContactsFils.Count() == 0)
                                        {
                                            Console.Write("Ce dossier " + dossierCourant.Nom + " ne contient pas de contacts. En conséquence : ");
                                            commandeValide = false;
                                        }
                                        else
                                        {
                                            if (indicePassedEnCommande >= dossierCourant.ContactsFils.Count())
                                            {
                                                int borneMax = dossierCourant.DossiersFils.Count() - 1;
                                                Console.Write("Vous confondez un Contact avec un Dossier mdr. Pour manipuler un Contact contenu dans " + dossierCourant.Nom + ", réessayez avec un indice compris entre 0 et " + borneMax + " inclus... En attendant : ");
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                

                // Exécution effective de la commande après avoir filtré toutes les erreurs. Les seules erreurs pouvant encore survenir sont des erreurs d'ouverture de fichier avec les commandes SHOW... et GET... ou alors des erreurs de password avec GET...
                if(commandeValide)
                {
                    if (commandePassed == Commande.MAN)
                    {
                        Console.Write("\n");
                        for (int i = 0; i < nbrCommandes; i++)
                        {
                            string ligneSortable = "";
                            if(i < (int)Commande.SAUVDOSSIERXML)
                            {
                                ligneSortable = String.Format("{0, -9}", ((Commande)i).ToString());
                            }
                            else
                            {
                                ligneSortable = String.Format("{0, -22}", ((Commande)i).ToString());
                            }
                            bool mettreOU = false;
                            if (i != (int)Commande.INUTILE)
                            {
                                if (intCommandesConcernedPar1.estDansList(i))
                                {
                                    ligneSortable += " --> pas de paramètres";
                                    mettreOU = true;
                                }
                                if (intCommandesConcernedPar2int.estDansList(i))
                                {
                                    if (mettreOU)
                                    {
                                        ligneSortable += " OU ";
                                    }
                                    else
                                    {
                                        ligneSortable += " --> ";
                                        mettreOU = true;
                                    }
                                    ligneSortable += "un indice (int)";
                                }
                                if (intCommandesConcernedPar2string.estDansList(i))
                                {
                                    if (mettreOU)
                                    {
                                        ligneSortable += " OU ";
                                    }
                                    else
                                    {
                                        ligneSortable += " --> ";
                                        mettreOU = true;
                                    }
                                    ligneSortable += "un nom (string)";
                                }
                                if (intCommandesConcernedPar3intString.estDansList(i))
                                {
                                    if (mettreOU)
                                    {
                                        ligneSortable += " OU ";
                                    }
                                    else
                                    {
                                        ligneSortable += " --> ";
                                        mettreOU = true;
                                    }
                                    ligneSortable += "(un indice (int) ET un nom (string))";
                                }
                            }

                            string valeurDictionnaireRecup = "";
                            dictionnaireInfosMan.TryGetValue(i, out valeurDictionnaireRecup);
                            ligneSortable += valeurDictionnaireRecup;

                            Console.Write(ligneSortable + "\n");
                        }
                    }
                    else if (commandePassed == Commande.TREE)
                    {
                        Console.Write("\n");
                        dossierCourant.afficherArborescenceFille("-");
                    }
                    else if (commandePassed == Commande.LSDATE)
                    {
                        Console.Write("\n");
                        dossierCourant.afficherDossierEtSonContenu(true);
                    }
                    else if (commandePassed == Commande.LS)
                    {
                        Console.Write("\n");
                        dossierCourant.afficherDossierEtSonContenu(false);
                    }
                    else if (commandePassed == Commande.MKDIR)
                    {
                        Dossier nouveauDossier = new Dossier(stringpassedEnCommande, dossierCourant);
                    }
                    else if (commandePassed == Commande.MKCONTACT)
                    {
                        Console.Write("\n");
                        Contact nouveauContact = new Contact();
                        nouveauContact.formulaireCreationContact(dossierCourant);
                    }
                    else if (commandePassed == Commande.EXIT)
                    {
                        continuer = false;
                    }
                    else if (commandePassed == Commande.CD)
                    {
                        if (nbrElementsCommande == 1)
                        {
                            dossierCourant = dossierRoot;
                        }
                        else if (nbrElementsCommande == 2)
                        {
                            if (indicePassedEnCommande < 0)
                            {
                                while (indicePassedEnCommande < 0)
                                {
                                    dossierCourant = dossierCourant.DossierParent;
                                    indicePassedEnCommande++;
                                }
                            }
                            else
                            {
                                dossierCourant = dossierCourant.DossiersFils[indicePassedEnCommande];
                            }
                        }
                    }
                    else if (intCommandesContenantPrecisions.estDansList((int)commandePassed))
                    {
                        if (intCommandesDemandantPassword.estDansList((int)commandePassed))
                        {
                            Console.Write("Password : ");
                            passwordSaisi = Console.ReadLine();
                            Console.Write("\n");
                        }

                        if (intCommandesSAUV.estDansList((int)commandePassed))
                        {
                            ElementArborescence elementPourSerialisation = dossierCourant;

                            if (intCommandesConcernedParIndiceDossier.estDansList((int)commandePassed))
                            {
                                Dossier dossierFictif = dossierCourant;
                                if (indicePassedEnCommandeEstUnInt)
                                {
                                    if (indicePassedEnCommande < 0)
                                    {
                                        while (indicePassedEnCommande < 0)
                                        {
                                            dossierFictif = dossierFictif.DossierParent;
                                            indicePassedEnCommande++;
                                        }
                                    }
                                    else
                                    {
                                        dossierFictif = dossierFictif.DossiersFils[indicePassedEnCommande];
                                    }
                                }

                                if (nbrElementsCommande == 1 || (nbrElementsCommande == 2 && indicePassedEnCommandeEstUnInt))
                                {
                                    cheminFichier += "sauv_" + dossierCourant.Nom;
                                }
                                else
                                {
                                    cheminFichier += stringpassedEnCommande;
                                }

                                elementPourSerialisation = dossierFictif;
                            }
                            else if (intCommandesConcernedParIndiceContact.estDansList((int)commandePassed))
                            {
                                elementPourSerialisation = dossierCourant.ContactsFils[indicePassedEnCommande];

                                if (nbrElementsCommande == 2)
                                {
                                    cheminFichier += "sauv_" + dossierCourant.Nom;
                                }
                                else if (nbrElementsCommande == 3)
                                {
                                    cheminFichier += stringpassedEnCommande;
                                }
                            }

                            if (trueUncryptedFalseCrypted)
                            {
                                problemeDeFichier = !elementPourSerialisation.serialiserElementArborescenceIntoFichier(cheminFichier, trueXMLfalseBIN);
                            }
                            else
                            {
                                problemeDeFichier = !elementPourSerialisation.serialiserChiffrerElementArborescenceIntoFichier(cheminFichier, trueXMLfalseBIN, passwordSaisi);
                            }
                        }
                        else if (intCommandesSHOW.estDansList((int)commandePassed))
                        {
                            Console.Write("\n");
                            try
                            {
                                string[] files = System.IO.Directory.GetFiles(cheminFichier);
                                foreach (string file in files)
                                {
                                    Console.Write(file.Replace(cheminFichier, "") + "\n");
                                }
                                commandeValide = true;
                            }
                            catch (System.IO.DirectoryNotFoundException)
                            {
                                Console.Write("Fichier non trouvé, en conséquence : ");
                                problemeDeFichier = true;
                            }
                        }
                        else if (intCommandesGET.estDansList((int)commandePassed))
                        {
                            Console.Write("\n");
                            cheminFichier += stringpassedEnCommande;
                            if (trueUncryptedFalseCrypted)
                            {
                                problemeDeFichier = !dossierCourant.deserialiserFichierIntoElementArborescence(cheminFichier, trueXMLfalseBIN, trueDossierfalseContact);
                            }
                            else
                            {
                                problemeDeFichier = !dossierCourant.dechiffrerDeserialiserFichierIntoElementArborescence(cheminFichier, trueXMLfalseBIN, trueDossierfalseContact, passwordSaisi);
                            }
                        }
                    }
                }
                if (!commandeValide || problemeDeFichier)
                {
                    Console.Write("Commande non aboutie, t'as le seum mon reuf !\n");
                }
            }
        }
    }
}
